#include <nds.h>
#include <stdio.h>
	#include "protos.h"
	#include "screenshot.h"
	#include "weapon.h"
	#include "sub_raw.h"


void lookEvent(void)
{
	scanKeys();
	newStylus = touchReadXY();
	
	
	if(keysDown() & KEY_START)
		screenshot("shot.bmp");
		
	if(keysHeld() & KEY_UP || keysHeld() & KEY_X)
	{
		joueur.posX += MY_COS(joueur.angle) / carte.cubeSize / 2;
		joueur.posY += MY_SIN(joueur.angle) / carte.cubeSize / 2;
	}
	if(keysHeld() & KEY_DOWN || keysHeld() & KEY_B)
	{
		joueur.posX -= MY_COS(joueur.angle) / carte.cubeSize / 2;
		joueur.posY -= MY_SIN(joueur.angle) / carte.cubeSize / 2;
	}
	if(keysHeld() & KEY_RIGHT || keysHeld() & KEY_A)
		joueur.angle += 4;
	if(keysHeld() & KEY_LEFT || keysHeld() & KEY_Y)
		joueur.angle -= 4;
	
	if((keysHeld() & KEY_R || keysHeld() & KEY_L) && emit >= 5)
	{
		drawBitmap((u16*)weaponBitmap, 155, 111, 24, 16, 256 * 192, 0x7C1F);
		playGenericSound(sub_raw, sub_raw_size);
		emit = 0;
	}
	else if(emit == 1)
	{
		drawBitmap((u16*)weaponBitmap, 155, 111, 24, 16, 0, 0x7C1F);
	}
	
	if(keysDown() & KEY_TOUCH)
	{
		oldStylus = newStylus;
	}
	else if(keysHeld() & KEY_TOUCH)
	{
		if((newStylus.px - oldStylus.px) > 1 || (newStylus.px - oldStylus.px) < -1)
			joueur.angle += (newStylus.px - oldStylus.px) * 2;
		if((newStylus.py - oldStylus.py) > 1 || (newStylus.py - oldStylus.py) < -1)
			joueur.view += (oldStylus.py - newStylus.py) * 2;
	}
	
	oldStylus = newStylus;
	joueur.hauteur = (carte.map[(joueur.posY / carte.cubeSize) * carte.sX + (joueur.posX / carte.cubeSize)] + 4) * carte.cubeSize;
	
	emit++;
	joueur.angle &= 511;
	joueur.view &= 511;
	
	CheckCollisions();
}


u8 GetTile(s8 x, s8 y)
{
	if (x < 0 || y < 0) return 20; // Say it was a collision...
	return carte.map[y * carte.sX + x];
}

s8 LeftCollision(void)
{
	return (GetTile(joueur.posX / carte.cubeSize - 1, joueur.posY / carte.cubeSize) - GetTile(joueur.posX / carte.cubeSize, joueur.posY / carte.cubeSize));
}

s8 RightCollision(void)
{
	return (GetTile(joueur.posX / carte.cubeSize + 1, joueur.posY / carte.cubeSize) - GetTile(joueur.posX / carte.cubeSize, joueur.posY / carte.cubeSize));
}

s8 FrontCollision(void)
{
	return (GetTile(joueur.posX / carte.cubeSize, joueur.posY / carte.cubeSize + 1) - GetTile(joueur.posX / carte.cubeSize, joueur.posY / carte.cubeSize));
}

s8 BackCollision(void)
{
	return (GetTile(joueur.posX / carte.cubeSize, joueur.posY / carte.cubeSize - 1) - GetTile(joueur.posX / carte.cubeSize, joueur.posY / carte.cubeSize));
}

s8 CornerFLCollision(void)
{
	return (GetTile(joueur.posX / carte.cubeSize - 1, joueur.posY / carte.cubeSize + 1) - GetTile(joueur.posX / carte.cubeSize, joueur.posY / carte.cubeSize));
}

s8 CornerFRCollision(void)
{
	return (GetTile(joueur.posX / carte.cubeSize + 1, joueur.posY / carte.cubeSize + 1) - GetTile(joueur.posX / carte.cubeSize, joueur.posY / carte.cubeSize));
}

s8 CornerBRCollision(void)
{
	return (GetTile(joueur.posX / carte.cubeSize + 1, joueur.posY / carte.cubeSize - 1) - GetTile(joueur.posX / carte.cubeSize, joueur.posY / carte.cubeSize));
}

s8 CornerBLCollision(void)
{
	return (GetTile(joueur.posX / carte.cubeSize - 1, joueur.posY / carte.cubeSize - 1) - GetTile(joueur.posX / carte.cubeSize, joueur.posY / carte.cubeSize));
}

void CheckCollisions(void)
{
	while(LeftCollision() > 1)
	{
		joueur.posX += carte.cubeSize / 8;
	}
	while(RightCollision() > 1)
	{
		joueur.posX -= carte.cubeSize / 8;
	}
	while(FrontCollision() > 1)
	{
		joueur.posY -= carte.cubeSize / 8;
	}
	while(BackCollision() > 1)
	{
		joueur.posY += carte.cubeSize / 8;
	}
	while(CornerFLCollision() > 1)
	{
		joueur.posX += carte.cubeSize / 8;
		joueur.posY -= carte.cubeSize / 8;
	}
	while(CornerFRCollision() > 1)
	{
		joueur.posX -= carte.cubeSize / 8;
		joueur.posY -= carte.cubeSize / 8;
	}
	while(CornerBRCollision() > 1)
	{
		joueur.posX -= carte.cubeSize / 8;
		joueur.posY += carte.cubeSize / 8;
	}
	while(CornerBLCollision() > 1)
	{
		joueur.posX += carte.cubeSize / 8;
		joueur.posY += carte.cubeSize / 8;
	}

}

